// softuart-echo-final.c

#include <avr/io.h>
#include <util/delay_basic.h>

unsigned char n,A_Reg,c,E_Reg;


void WrCOM(){
	PORTB |=(1<<PB1);    // TXD = 1
	_delay_loop_1(150);
	for (c=0;c<8;c++){
		if((E_Reg & 1)==0){
			PORTB |=(1<<PB1);    // TXD = 1   
		}
		else{
			PORTB &=~(1<<PB1);   // TXD = 0
		}
	_delay_loop_1(150);
		E_Reg=E_Reg>>1;
	}
	PORTB &=~(1<<PB1);   // TXD = 0
	_delay_loop_1(153);
}


void RdCOM(){
	while((PINB & 4)==0);
	_delay_loop_1(230);
 	E_Reg=0;
	for(c=0;c<8;c++){
		E_Reg=E_Reg>>1;
		if((PINB & 4)==4){
			E_Reg=E_Reg|128;
		}
	_delay_loop_1(153);
	}
	_delay_loop_1(150);
	E_Reg =~E_Reg;      // oder: E_Reg=255-E_Reg;
}


void main(){

DDRB=0b00000010;  // PB1:Ausgang
PORTB=0b00011001;  // Pullups an ungenutzten Eingängen

//E_Reg = 85;
//WrCOM();

	while(1){
		RdCOM();
//		E_Reg = 85;
		WrCOM();
	}
}
